package com.marcosbarbero.tests;

import org.springframework.boot.SpringApplication;
import org.springframework.cloud.client.SpringCloudApplication;
import org.springframework.cloud.netflix.zuul.EnableZuulProxy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author Marcos Barbero
 * @since 2017-06-26
 */
@EnableZuulProxy
@SpringCloudApplication
public class SpringDataApplication {

    public static void main(String... args) {
        SpringApplication.run(SpringDataApplication.class, args);
    }


    @RestController
    public class ServiceController {

        public static final String RESPONSE_BODY = "ResponseBody";

        @GetMapping("/serviceA")
        public ResponseEntity<String> serviceA() {
            return ResponseEntity.ok(RESPONSE_BODY);
        }

        @GetMapping("/serviceB")
        public ResponseEntity<String> serviceB() {
            return ResponseEntity.ok(RESPONSE_BODY);
        }

        @GetMapping("/serviceC")
        public ResponseEntity<String> serviceC() {
            return ResponseEntity.ok(RESPONSE_BODY);
        }

        @GetMapping("/serviceD/{paramName}")
        public ResponseEntity<String> serviceD(@PathVariable String paramName) {
            return ResponseEntity.ok(RESPONSE_BODY + " " + paramName);
        }

        @GetMapping("/serviceE")
        public ResponseEntity<String> serviceE() throws InterruptedException {
            Thread.sleep(1100);
            return ResponseEntity.ok(RESPONSE_BODY);
        }

        @GetMapping("/serviceF")
        public ResponseEntity<String> serviceF() {
            return ResponseEntity.ok(RESPONSE_BODY);
        }

        @GetMapping("/serviceG")
        public ResponseEntity<String> serviceG() {
            return ResponseEntity.ok(RESPONSE_BODY);
        }

        @GetMapping("/serviceH")
        public ResponseEntity<String> serviceH() {
            return ResponseEntity.ok(RESPONSE_BODY);
        }

        @GetMapping("/serviceI")
        public ResponseEntity<String> serviceI() {
            return ResponseEntity.ok(RESPONSE_BODY);
        }
    }
}
